# coding: utf-8


"""
IGNORE:
    Nutanix Iam Versioned APIs

    Identity and Access Management in Nutanix cluster.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_iam_py_client.Ntnx.iam.v4.authn.NameIdPolicyFormat import NameIdPolicyFormat  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class IdpProperties(object):
    """IdpProperties - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'entity_id': 'str',
        'login_url': 'str',
        'logout_url': 'str',
        'error_url': 'str',
        'certificate': 'str',
        'name_id_policy_format': 'iam.v4.authn.NameIdPolicyFormat',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'entity_id': 'entityId',
        'login_url': 'loginUrl',
        'logout_url': 'logoutUrl',
        'error_url': 'errorUrl',
        'certificate': 'certificate',
        'name_id_policy_format': 'nameIdPolicyFormat',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, entity_id=None, login_url=None, logout_url=None, error_url=None, certificate=None, name_id_policy_format=None, *args, **kwargs):  # noqa: E501
        """IdpProperties - a model defined in Swagger
            \nInformation of the IDP
        """
        self.__entity_id = None
        self.__login_url = None
        self.__logout_url = None
        self.__error_url = None
        self.__certificate = None
        self.__name_id_policy_format = None
        self.discriminator = None
        self.__entity_id = entity_id
        self.__login_url = login_url
        if logout_url is not None:
            self.__logout_url = logout_url
        if error_url is not None:
            self.__error_url = error_url
        self.__certificate = certificate
        if name_id_policy_format is not None:
            self.__name_id_policy_format = name_id_policy_format
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'iam.v4.authn.IdpProperties'

    def _initialize_fq_object_type(self):
        return 'iam.v4.r0.a1.authn.IdpProperties'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def entity_id(self):
        """`{ str }`
            \nEntity Id of Identity provider
        """ # noqa: E501
        return self.__entity_id

    @entity_id.setter
    def entity_id(self, entity_id):
        if entity_id is None:
            raise ValueError("Invalid value for `entity_id`, must not be `None`")  # noqa: E501
        if entity_id is not None and len(entity_id) > 2000:
            raise ValueError("Invalid value for `entity_id`, length must be less than or equal to `2000`")  # noqa: E501
        if entity_id is not None and len(entity_id) < 3:
            raise ValueError("Invalid value for `entity_id`, length must be greater than or equal to `3`")  # noqa: E501

        self.__entity_id = entity_id

    @property
    def login_url(self):
        """`{ str }`
            \nLogin URL of the Identity provider
        """ # noqa: E501
        return self.__login_url

    @login_url.setter
    def login_url(self, login_url):
        if login_url is None:
            raise ValueError("Invalid value for `login_url`, must not be `None`")  # noqa: E501
        if login_url is not None and len(login_url) > 2000:
            raise ValueError("Invalid value for `login_url`, length must be less than or equal to `2000`")  # noqa: E501
        if login_url is not None and len(login_url) < 3:
            raise ValueError("Invalid value for `login_url`, length must be greater than or equal to `3`")  # noqa: E501
        if login_url is not None and not re.search('^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', login_url):  # noqa: E501
            raise ValueError(r"Invalid value for `login_url`, must be a follow pattern or equal to `/^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__login_url = login_url

    @property
    def logout_url(self):
        """`{ str }`
            \nLogout URL of the Identity provider
        """ # noqa: E501
        return self.__logout_url

    @logout_url.setter
    def logout_url(self, logout_url):
        if logout_url is not None and len(logout_url) > 2000:
            raise ValueError("Invalid value for `logout_url`, length must be less than or equal to `2000`")  # noqa: E501
        if logout_url is not None and len(logout_url) < 3:
            raise ValueError("Invalid value for `logout_url`, length must be greater than or equal to `3`")  # noqa: E501
        if logout_url is not None and not re.search('^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', logout_url):  # noqa: E501
            raise ValueError(r"Invalid value for `logout_url`, must be a follow pattern or equal to `/^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__logout_url = logout_url

    @property
    def error_url(self):
        """`{ str }`
            \nError URL of the Identity provider
        """ # noqa: E501
        return self.__error_url

    @error_url.setter
    def error_url(self, error_url):
        if error_url is not None and len(error_url) > 2000:
            raise ValueError("Invalid value for `error_url`, length must be less than or equal to `2000`")  # noqa: E501
        if error_url is not None and len(error_url) < 3:
            raise ValueError("Invalid value for `error_url`, length must be greater than or equal to `3`")  # noqa: E501
        if error_url is not None and not re.search('^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$', error_url):  # noqa: E501
            raise ValueError(r"Invalid value for `error_url`, must be a follow pattern or equal to `/^((http[s]?):\/)?\/?([^:\/\\s]*)((\/\\w+)*(:[0-9]+)*?\/)([\\w\\-\\.]+[^#?\\s]+)(.*)?(#[\\w\\-]+)?$/`")  # noqa: E501

        self.__error_url = error_url

    @property
    def certificate(self):
        """`{ str }`
            \nCertificate for verification
        """ # noqa: E501
        return self.__certificate

    @certificate.setter
    def certificate(self, certificate):
        if certificate is None:
            raise ValueError("Invalid value for `certificate`, must not be `None`")  # noqa: E501
        if certificate is not None and len(certificate) < 64:
            raise ValueError("Invalid value for `certificate`, length must be greater than or equal to `64`")  # noqa: E501

        self.__certificate = certificate

    @property
    def name_id_policy_format(self):
        """`{ iam.v4.authn.NameIdPolicyFormat }`
            
        """ # noqa: E501
        return self.__name_id_policy_format

    @name_id_policy_format.setter
    def name_id_policy_format(self, name_id_policy_format):

        self.__name_id_policy_format = name_id_policy_format

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IdpProperties, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IdpProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

