# coding: utf-8


"""
IGNORE:
    Nutanix Iam Versioned APIs

    Identity and Access Management in Nutanix cluster.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class UserConfiguration(object):
    """UserConfiguration - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'user_object_class': 'str',
        'user_search_base': 'str',
        'username_attribute': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'user_object_class': 'userObjectClass',
        'user_search_base': 'userSearchBase',
        'username_attribute': 'usernameAttribute',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, user_object_class=None, user_search_base=None, username_attribute=None, *args, **kwargs):  # noqa: E501
        """UserConfiguration - a model defined in Swagger
            \nUser configuration for OpenLDAP directory service
        """
        self.__user_object_class = None
        self.__user_search_base = None
        self.__username_attribute = None
        self.discriminator = None
        self.__user_object_class = user_object_class
        self.__user_search_base = user_search_base
        self.__username_attribute = username_attribute
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'iam.v4.authn.UserConfiguration'

    def _initialize_fq_object_type(self):
        return 'iam.v4.r0.a1.authn.UserConfiguration'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def user_object_class(self):
        """`{ str }`
            \nObject class in the OpenLDAP system that corresponds to users
        """ # noqa: E501
        return self.__user_object_class

    @user_object_class.setter
    def user_object_class(self, user_object_class):
        if user_object_class is None:
            raise ValueError("Invalid value for `user_object_class`, must not be `None`")  # noqa: E501
        if user_object_class is not None and len(user_object_class) > 64:
            raise ValueError("Invalid value for `user_object_class`, length must be less than or equal to `64`")  # noqa: E501

        self.__user_object_class = user_object_class

    @property
    def user_search_base(self):
        """`{ str }`
            \nBase DN for user search
        """ # noqa: E501
        return self.__user_search_base

    @user_search_base.setter
    def user_search_base(self, user_search_base):
        if user_search_base is None:
            raise ValueError("Invalid value for `user_search_base`, must not be `None`")  # noqa: E501
        if user_search_base is not None and len(user_search_base) > 200:
            raise ValueError("Invalid value for `user_search_base`, length must be less than or equal to `200`")  # noqa: E501

        self.__user_search_base = user_search_base

    @property
    def username_attribute(self):
        """`{ str }`
            \nUnique identifier for each user which can be used in authentication
        """ # noqa: E501
        return self.__username_attribute

    @username_attribute.setter
    def username_attribute(self, username_attribute):
        if username_attribute is None:
            raise ValueError("Invalid value for `username_attribute`, must not be `None`")  # noqa: E501
        if username_attribute is not None and len(username_attribute) > 64:
            raise ValueError("Invalid value for `username_attribute`, length must be less than or equal to `64`")  # noqa: E501

        self.__username_attribute = username_attribute

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

